"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  exportWorker: () => exportWorker
});
module.exports = __toCommonJS(src_exports);

// src/shim.js
var React = __toESM(require("react"));

// src/exportWorker.ts
function exportWorker(fn) {
  self.onmessage = function({ data }) {
    console.log(data, "receive data");
    const result = fn(data);
    self.postMessage(result);
  };
}

// src/useWorker.ts
var import_react = require("react");
function useWorker(worker, input, shouldManual = false) {
  console.log("useWorker", worker, input, shouldManual);
  const [data, setData] = (0, import_react.useState)();
  const lastWorker = (0, import_react.useRef)(worker);
  (0, import_react.useEffect)(() => {
    lastWorker.current = worker;
    worker.addEventListener("message", (e) => {
      console.log(e);
      setData(e.data);
    });
    worker.addEventListener("error", (e) => {
      console.log(e);
    });
    worker.addEventListener("messageerror", (e) => {
      console.log(e);
    });
    return () => {
      worker.terminate();
    };
  }, [worker]);
  (0, import_react.useEffect)(() => {
    console.log(shouldManual);
    if (!shouldManual) {
      console.log("hi");
      lastWorker.current.postMessage(input);
    }
  }, [input, shouldManual]);
  return {
    data,
    shouldManual: false
  };
}

// src/index.ts
var src_default = useWorker;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  exportWorker
});
